# Twitter External Translator

> Adds "Translate with ..." to Tweet and User Bio on various sites.

*This originally was a fork of [DeepL Twitter translation](https://greasyfork.org/scripts/411976)*

***

| Version | Link | Alternative | Note |
|:----------:|:----------:|:----------:|:----------:|
Stable | [(GitHub) Install](https://github.com/magicoflolis/twitter-translator/releases/latest/download/twittertranslator.user.js) | [Greasy Fork](https://greasyfork.org/scripts/421643) | Recommended version.
Legacy | [(GitHub) Install](https://github.com/magicoflolis/twitter-translator/raw/master/dist/twittertranslatorlegacy.user.js) | - | For incompatibility issues.

***

| Preview |
|:----------:|
![Menu Preview](https://raw.githubusercontent.com/magicoflolis/twitter-translator/master/assets/ExternalTranslator.gif)|

## Changelog

> [(GitHub) Full Changelog](https://github.com/magicoflolis/twitter-translator/releases)

## Features

> The menu and CSS have been compressed to reduce file size. Comments can be found under `src/main.js` on GitHub.

* Support for External & Internal Translators!
* Multi language Config menu!
* Multi language Translator support!
* Colors and themes can be customized.
* Automatically match websites Theme
* Automatically match websites Language
* Supports mobile [Twitter](https://mobile.twitter.com/)
* Supports [TwitLonger](https://www.twitlonger.com)
* Supports [TweetDeck](https://tweetdeck.twitter.com)
* Supports every [Nitter](https://github.com/zedeus/nitter/wiki/Instances#official-instances)
* Support for multiple Bios / Tweets on websites!
* [ Misc ] Works while logged out!
* [ Misc ] "Restore to Defaults" button.
* [ WIP ] Added help for each menu item.

### Supported

Translator | External | Website | Internal |
:---------:|:-----------:|:-----------:|:---------:|
Bing Microsoft Translator | ✅ |[link](https://www.bing.com/translator)| ❌ |
DeepL Translate | ✅ |[link](https://www.deepl.com/translator)| ✅ |
Google Translate | ✅ |[link](https://translate.google.com/)| ✅ |
LibreTranslate | ❌ |[link](https://libretranslate.com/)| ✅ |
Lingva Translate | ✅ |[link](https://lingva.ml/)| ✅ |
MyMemory | ✅ |[link](https://mymemory.translated.net/)| ✅ |
Translate.com | ✅ |[link](https://www.translate.com/)| ❌ |
Yandex Translate | ✅ |[link](https://translate.yandex.com/)| ❌ |

## Documentation

* [(GitHub) Wiki](https://github.com/magicoflolis/twitter-translator/wiki)

## Bugs / Issues

* [ User Script ] *May* conflict with [Magic Userscript+ : Show Site All UserJS](https://greasyfork.org/scripts/421603).
* [ Translator ] MyMemory API doesn't work in Bios.
* [ Menu ] Cannot be moved or disabled. ( WIP )

**Footnotes:**

* [ Translator ] Twitters built-in translation uses Google Translate, TweetDeck uses Bing Microsoft Translator.
* [ Translator ] Yandex Translate may default to Russian.
![YandexHelp](https://raw.githubusercontent.com/magicoflolis/twitter-translator/master/assets/ExternalTranslator4.gif)

## Source Code

[https://github.com/magicoflolis/twitter-translator](https://github.com/magicoflolis/twitter-translator)

## Contacts

* [GitHub](https://github.com/magicoflolis)
* [Twitter](https://twitter.com/for_lollipops)
* [Greasy Fork](https://greasyfork.org/users/166061)

## Roadmap

* Fix any bugs along the way.
* Automatically match Twitter colors.
* Show multiple translators at once.
* Support for direct messages.
* Support more translators.
